<?php

include_once("StaticPages.php");

# In StaticPages.php this is linked:  $LinkFunctions['<:page>'] = 'LinkToPossibleStaticPage';
function LinkToPossibleStaticPage($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
    
    global $StaticPageDir, $ApplicationPathUrl;
	
    $link = LinkPage($pagename,$imap,$path,$title,$txt,$fmt);
    
    $targetPageName = getLinkTargetPageName($pagename, $path);
    
    # Not a STATIC LINK if the the $path link defined (possible value Main/HomePage)
    # is part of the exclude list
    global $StaticPageExclude;
    if (isset($StaticPageExclude) && is_array($StaticPageExclude) 
    		&& in_array($targetPageName, $StaticPageExclude)){
    	// Remove Static Page if it exists
    	@removeStaticPage($targetPageName);
    	return $link;
    }
    
    #If file does not exist in $WorkDir directory (eg wiki.d) then skip make static file
    global $ApplicationPathDir, $WorkDir;
    $linkedWorkingPageDir = $ApplicationPathDir . "/" .
    	$WorkDir . "/" . $targetPageName;
    #echo "linkedWorkingPageDir:  $linkedWorkingPageDir <br/>";
    if (!file_exists($linkedWorkingPageDir)){
    	return $link;
    }
    
    $hrefToken = "'";
    $hrefStart = strpos($link, "'", strpos($link, "href"));    
    $hrefStop = strpos($link, "'", $hrefStart + 1);
    $hrefText = substr($link, $hrefStart + 1, $hrefStop - $hrefStart - 1);
    
    // Static pages will have only one argument in the form of "?n=Main.Page"
    $isStaticPage = FALSE;
    $hrefParts = explode("?", $hrefText);  // $args[0] is html link, $args[>0] is the arguments
    $wikiLinkPart = $hrefParts[1];
    
    if (count($hrefParts) <= 2 && (strcmp("n=", substr($wikiLinkPart, 0, 2)) == 0) ){
        $isStaticPage = TRUE;
    }
    
    if ($isStaticPage == FALSE){
        return $link;
    }
    
    $newLink = $ApplicationPathUrl . "/" . $StaticPageDir . "/"
        . getStaticPageNameFromWikiLink(substr($wikiLinkPart, 2));
        
    $link = substr_replace($link, $newLink, $hrefStart + 1, $hrefStop - $hrefStart - 1);
    
    return $link;
}


function getStaticPageNameFromWikiLink($wikiLink){
    #$wikiLink In the form of "Main.HomePage"
    
    if (strlen($wikiLink) < 3 || strpos($wikiLink, ".") == FALSE){
    	return "Main_HomePage.html";  # Default if not specified
    }
    
    $wikiLinkGroupName = substr($wikiLink, 0, strpos($wikiLink, "."));
    $wikiLinkPageName = substr($wikiLink, strpos($wikiLink, ".") + 1, strlen($wikiLink) - 1);
    
    return $wikiLinkGroupName . "_" .$wikiLinkPageName .".html";
}

function createStaticPage($wikiLink){
   	
   	# If it is part of exclude list, skip it
    global $StaticPageExclude;
    if (isset($StaticPageExclude) && is_array($StaticPageExclude) 
    		&& in_array($wikiLink, $StaticPageExclude)){
    	// Remove Static Page if it exists
    	@removeStaticPage($wikiLink);
    	return $wikiLink;
    }
   	
    global $ScriptUrl, $StaticPageDir, $ApplicationPathDir;
    
    $wikiLinkAddress = $ScriptUrl . "?n=" . $wikiLink;
    $wikiLinkStaticPageDir = $ApplicationPathDir . "/" .
    	$StaticPageDir . "/" . getStaticPageNameFromWikiLink($wikiLink);
	
    if (! ($wikiLinkPageContents = file_get_contents($wikiLinkAddress)) ){
    	echo "Could not open URL for copying:  " .  $wikiLinkAddress;
    	return;
    }
    
	
    if (!is_dir($StaticPageDir)){
    	
    	# Permissions - Global Read and Write Access, No Execute
    	if (!MakeDirectoryPath($StaticPageDir, 0006)){
    		echo "Could not create output directory for static files:  " .  $StaticPageDir;
       		return;
    	}
    }
    
    if (!($fpStaticPage = fopen($wikiLinkStaticPageDir , "w+"))){
       echo "Could not open file for writing:  " .  $wikiLinkStaticPageDir;
       return;
    }
    
    if (!(fwrite($fpStaticPage, $wikiLinkPageContents))){
       echo "Could not write to file:  " .  $wikiLinkStaticPageDir;
       return;
    }
    
    fclose($fpStaticPage);
    
}

function removeStaticPage($wikiLink){
	global $StaticPageDir, $ApplicationPathDir;
	
	if (isset($wikiLink) && strlen($wikiLink) > 1 && !(substr($wikiLink, 0, 1) == ".")){
		unlink($ApplicationPathDir . "/" . 
			$StaticPageDir . "/" . getStaticPageNameFromWikiLink($wikiLink));  
	}
}


function MakeDirectoryPath($path, $mode = 0755){
	
	# Attempt to create $dir directory
	if (is_dir($path) || @mkdir($path,$mode)){
		return TRUE;
	}
	# Attempt to create parent directory
	if (!MakeDirectoryPath(dirname($path),$mode)){
		return FALSE;
	}
	
	# Attempt again to create this directory
	return @mkdir($path,$mode);
}

function getLinkTargetPageName($pagename, $path){
	global $QueryFragPattern;
    
    if (!preg_match("/^\\s*([^#?]+)($QueryFragPattern)?$/", $path, $match)){
    	return "";	
    }
    
    $targetPageName = MakePageName($pagename, $match[1]); 
    if (!$targetPageName){
    	return "";
    }else{
    	return $targetPageName;
    }
}
?>